#include <cstdio>

// ===========================================================================
// Constantes.

const struct { int dl, dc; } DEP[4] = {
    {0,1}, {0,-1}, {1,0}, {-1,0}
};

// ===========================================================================
// Donnes globales.

int n;
char map[1000][1000];

// ===========================================================================
// Fonction principale.

int main()
{
    scanf("%d", &n);
    for (int i = 0; i < n; i++)
        scanf("%s", map[i]);
    
    for (int l = 0; l < n; l++) {
        for (int c = 0; c < n; c++) {
            int cpt = (map[l][c] == '#');
            
            for (int v = 0; v < 4; v++) {
                int nc = c + DEP[v].dc;
                int nl = l + DEP[v].dl;
                if (nl >= 0 && nl < n && nc >= 0 && nc < n)
                    cpt += (map[nl][nc] == '#');
            }
            
            if (cpt % 2 == 0) {
               printf("Invalide en (%d, %d).\n", l, c);
                return 0;
            }
        }
    }
    
    printf("Valide.\n");
    return 0;
}
